Lucene++ - a full-featured, c++ search engine
API Documentation

- Main Page
- Related Pages
- Namespaces
- Data Structures
- Files

- Data Structures
- Class Hierarchy
- Data Fields

Public Member Functions | Protected Attributes
Lucene::NumericComparator< TYPE > Class Template Reference

`#include <FieldComparator.h>`

Inheritance diagram for Lucene::NumericComparator< TYPE >:

## Public Member Functions

| NumericComparator (int32_t numHits, const String &field=EmptyString)
virtual | ~NumericComparator ()
virtual int32_t | compare (int32_t slot1, int32_t slot2)
| Compare hit at slot1 with hit at slot2. More...
virtual int32_t | compareBottom (int32_t doc)
| Compare the bottom of the queue with doc. This will only invoked after setBottom has been called. This should return the same result as compare(int,int)} as if bottom were slot1 and the new document were slot 2. More...
virtual void | copy (int32_t slot, int32_t doc)
| This method is called when a new hit is competitive. You should copy any state associated with this document that will be required for future comparisons, into the specified slot. More...
virtual void | setBottom (int32_t slot)
| Set the bottom slot, ie the "weakest" (sorted last) entry in the queue. When compareBottom is called, you should compare against this slot. This will always be called before compareBottom. More...
virtual ComparableValue | value (int32_t slot)
| Return the actual value in the slot. More...
Public Member Functions inherited from Lucene::FieldComparator
virtual | ~FieldComparator ()
virtual String | getClassName ()
boost::shared_ptr< FieldComparator > | shared_from_this ()
virtual void | setNextReader (const IndexReaderPtr &reader, int32_t docBase)=0
| Set a new Reader. All doc correspond to the current Reader. More...
virtual void | setScorer (const ScorerPtr &scorer)
| Sets the Scorer to use in case a document's score is needed. More...
Public Member Functions inherited from Lucene::LuceneObject
virtual | ~LuceneObject ()
virtual void | initialize ()
| Called directly after instantiation to create objects that depend on this object being fully constructed. More...
virtual LuceneObjectPtr | clone (const LuceneObjectPtr &other=LuceneObjectPtr())
| Return clone of this object. More...
virtual int32_t | hashCode ()
| Return hash code for this object. More...
virtual bool | equals (const LuceneObjectPtr &other)
| Return whether two objects are equal. More...
virtual int32_t | compareTo (const LuceneObjectPtr &other)
| Compare two objects. More...
virtual String | toString ()
| Returns a string representation of the object. More...
Public Member Functions inherited from Lucene::LuceneSync
virtual | ~LuceneSync ()
virtual SynchronizePtr | getSync ()
| Return this object synchronize lock. More...
virtual LuceneSignalPtr | getSignal ()
| Return this object signal. More...
virtual void | lock (int32_t timeout=0)
| Lock this object using an optional timeout. More...
virtual void | unlock ()
| Unlock this object. More...
virtual bool | holdsLock ()
| Returns true if this object is currently locked by current thread. More...
virtual void | wait (int32_t timeout=0)
| Wait for signal using an optional timeout. More...
virtual void | notifyAll ()
| Notify all threads waiting for signal. More...

## Protected Attributes

Collection< TYPE > | values
Collection< TYPE > | currentReaderValues
String | field
TYPE | bottom
Protected Attributes inherited from Lucene::LuceneSync
SynchronizePtr | objectLock
LuceneSignalPtr | objectSignal

## Additional Inherited Members

Static Public Member Functions inherited from Lucene::FieldComparator
static String | _getClassName ()
Protected Member Functions inherited from Lucene::LuceneObject
| LuceneObject ()

## Constructor & Destructor Documentation

template<typename TYPE>

Lucene::NumericComparator< TYPE >::NumericComparator | ( | int32_t | numHits,
|  | const String & | field = `EmptyString`
| ) |  |

inline

template<typename TYPE>

virtual Lucene::NumericComparator< TYPE >::~NumericComparator | ( |  | ) |

inline virtual

## Member Function Documentation

template<typename TYPE>

virtual int32_t Lucene::NumericComparator< TYPE >::compare | ( | int32_t | slot1,
|  | int32_t | slot2
| ) |  |

inline virtual

Compare hit at slot1 with hit at slot2.

Parameters

  slot1 | first slot to compare
  slot2 | second slot to compare

Returns
  any N < 0 if slot2's value is sorted after slot1, any N > 0 if the slot2's value is sorted before slot1 and 0 if they are equal

Implements Lucene::FieldComparator.

Reimplemented in Lucene::RelevanceComparator, Lucene::LongComparator, Lucene::IntComparator, and Lucene::DoubleComparator.

template<typename TYPE>

virtual int32_t Lucene::NumericComparator< TYPE >::compareBottom | ( | int32_t | doc | ) |

inline virtual

Compare the bottom of the queue with doc. This will only invoked after setBottom has been called. This should return the same result as compare(int,int)} as if bottom were slot1 and the new document were slot 2.

For a search that hits many results, this method will be the hotspot (invoked by far the most frequently).

Parameters

  doc | that was hit

Returns
  any N < 0 if the doc's value is sorted after the bottom entry (not competitive), any N > 0 if the doc's value is sorted before the bottom entry and 0 if they are equal.

Implements Lucene::FieldComparator.

Reimplemented in Lucene::RelevanceComparator, Lucene::LongComparator, Lucene::IntComparator, Lucene::DoubleComparator, and Lucene::DocComparator.

template<typename TYPE>

virtual void Lucene::NumericComparator< TYPE >::copy | ( | int32_t | slot,
|  | int32_t | doc
| ) |  |

inline virtual

This method is called when a new hit is competitive. You should copy any state associated with this document that will be required for future comparisons, into the specified slot.

Parameters

  slot | which slot to copy the hit to
  doc | docID relative to current reader

Implements Lucene::FieldComparator.

Reimplemented in Lucene::RelevanceComparator, and Lucene::DocComparator.

template<typename TYPE>

virtual void Lucene::NumericComparator< TYPE >::setBottom | ( | int32_t | slot | ) |

inline virtual

Set the bottom slot, ie the "weakest" (sorted last) entry in the queue. When compareBottom is called, you should compare against this slot. This will always be called before compareBottom.

Parameters

  slot | the currently weakest (sorted last) slot in the queue

Implements Lucene::FieldComparator.

template<typename TYPE>

virtual ComparableValue Lucene::NumericComparator< TYPE >::value | ( | int32_t | slot | ) |

inline virtual

Return the actual value in the slot.

Parameters

  slot | the value

Returns
  value in this slot upgraded to ComparableValue

Implements Lucene::FieldComparator.

## Field Documentation

template<typename TYPE>

TYPE Lucene::NumericComparator< TYPE >::bottom

protected

Referenced by Lucene::NumericComparator< int32_t >::NumericComparator().

template<typename TYPE>

Collection<TYPE> Lucene::NumericComparator< TYPE >::currentReaderValues

protected

template<typename TYPE>

String Lucene::NumericComparator< TYPE >::field

protected

Referenced by Lucene::NumericComparator< int32_t >::NumericComparator().

template<typename TYPE>

Collection<TYPE> Lucene::NumericComparator< TYPE >::values

protected

Referenced by Lucene::NumericComparator< int32_t >::NumericComparator().

The documentation for this class was generated from the following file:

- FieldComparator.h

clucene.sourceforge.net